VPutMapMacro:
	ex (sp),hl ;don't destroy hl
	ld a,(hl)
	inc hl
	ld (pencol),a
	ld a,(hl)
	inc hl
	B_CALL VPutMap
	ex (sp),hl
	ret

	
PutS: 
;Displays a string on the screen in large font at the current cursor position. 
;INPUT:    HL->Zero terminated string. 
;OUTPUT:   HL->Byte after zero terminator. 
;DESTROYS: AF 
;PLATFORM: 73,83P 
       ld     a,(hl) 
       inc    hl 
       or     a 
       ret    z 
       B_CALL PutC 
       jr     PutS

convop1tostr:
	push bc
	ld a,7
	B_CALL FormEReal
	pop bc
	call getelementlocplusc
	ld hl,OP3
	;fallthrough
StrCpy: 
;HL = String (Null Terminated) 
;DE = Target 
   ld a,(hl) 
   ldi
   or a 
   jr nz,StrCpy 
	ret

MovFrOP1:
	ld hl,OP1
copy9:
	ldi
	ldi
	ldi
	ldi
	ldi
	ldi
	ldi
	ldi
	ldi
	ret

MovToOP2:
	ld de,OP2
	jr copy9
	
VDisplayA: ;prints a
	ld h,0
	ld l,a
VDisplayHL:
	B_CALL SetXXXXOP2
	B_CALL OP2ToOP1
	ld a,6
VDisplayOP1:
	B_CALL FormEReal
	ld hl,OP3
	B_CALL VPutS
	ret

VDisplayHL_indirect:
	rst 20h
	ld a,14
	jr VDisplayOP1

VPutS7:
	ld b,7
VPutS7_loop:
	ld a,(hl)
	inc hl
	or a
	jr z,VPutS7_skipput
	B_CALL VPutMap
VPutS7_skipput:
	djnz VPutS7_loop
	ret

VPutS: 
;Displays a string on the screen in small font at the current cursor position. 
;INPUT:    Same as VPutS (HL->String) 
;OUTPUT:   Same as VPutS (HL->Byte after zero terminator) 
;DESTROYS: AF 
;PLATFORM: 73,83P 
        ld      a,(hl) 
        inc     hl 
        or      a 
        ret     z 
        push    de 
        B_CALL  VPutMap 
        pop     de 
        ret     c 
        jr      VPutS

LdHLInd:
	LD A, (HL)
	INC HL
	LD H, (HL)
	LD L, A
	RET
