;Input using the system monitor
;modified from the code provided by Dan Englender


 nolist
 include "extraequ.inc"
 list

rawKeyHookPtr           equ 9B84h
_EnableRawKeyHook       equ 4F66h
_DisableRawKeyHook      equ 4F6Fh
rawKeyHookActive        equ 5
rawKeyHookFlag          equ 34h


tokenHookPtr            equ 9BC8h
_EnableTokenHook        equ 4F99h
_DisableTokenHook       equ 4F9Ch
tokenHookActive         equ 0
tokenHookFlag           equ 35h

_cxmainjump 	equ 4CABh
_OP1ToEdit		equ 49A5h
_SetNumWindow	equ 452Bh
_WPutSEOL		equ 4522h
_BufToTop		equ 4927h
_FDispEOL		equ 45A9h
_InsDisp_oneline equ 4756h
_cursorright 	equ 4942h
_cursorup		equ 4945h

_dispErrorScreeN	equ 49DEh

;Equates
TempSP        EQU input ;takes 2 bytes
lastlinesaveplace	equ input+2 ;takes 16 bytes

getkeyhooksave				equ input+18
tokenhookbitsave			equ input+19
pointersaveplace			equ input+20 ;takes up 6 bytes
toplinestr					equ input+26 ;str for the first line length max 17 bytes
Currentnr					equ input+43
OPline1						equ input+44
OPline2						equ input+53

moleculeinput	equ	1 ;asm_Flag1
reqposint		equ	2 ;asm_Flag1
updown			equ	3 ;asm_Flag1
calconly			equ	4 ;asm_Flag1
emptyedits		equ	5 ;asm_Flag1
continue			equ	6 ;asm_Flag1

getinput:
		ld hl,weightstr
		bit moleculeinput,(IY+asm_flag1)
		jr nz,$f
		ld de,toplinestr
		ld bc,17
		ldir
		bit emptyedits,(IY+asm_Flag1)
		jr nz,$f
		ld de,OPline1	
		ld hl,OPs
		ld bc,9*6
		ldir
$$:
       B_CALL ForceFullScreen             ;Start of the program
		 ;save hooks
		 xor a
		bit rawKeyHookActive,(IY+rawKeyHookFlag)
		jr z,no_getkey
		ld a,0FFh
no_getkey:
		ld (getkeyhooksave),a ; loads 0 if bit is z else FF
		xor a
		bit tokenHookActive,(IY+tokenHookFlag)
		jr z,no_parser
		ld a,0FFh
no_parser:
		ld (tokenhookbitsave),a ; loads 0 if bit is z else FF
		ld hl,rawKeyHookPtr		;from
		ld de,pointersaveplace	;to
		ld bc,03						;size
		ldir							;copy rawkeyhookptr
		ld hl,tokenHookPtr	;from
		ld bc,03						;size
		ldir							;copy tokenHookPtr
		 ;hooks saved
		 in a,(6)
		 ld hl,getkeyhook
		 B_CALL EnableRawKeyHook	;actually is getkeylikehook
		 ld hl,tokenhook
		 B_CALL EnableTokenHook
		 res lwrCaseActive,(iy+appLwrCaseFlag) 
		 bit moleculeinput,(IY+asm_Flag1) 
		 jr z,$f
		 set lwrCaseActive,(iy+appLwrCaseFlag) 
$$:
		 set fullScrnDraw,(IY+apiFlg4)
		 ld a,3
		 ld (Currentnr),a
		 res textWrite, (IY + sGrFlags)
		 bit continue, (IY+ asm_Flag1)
		 jr nz,getinput_continue
       call   GetMathInput    ;Get some input!
		 jr getinput_finish
getinput_continue:
		 bit moleculeinput,(IY+asm_Flag1)
		 jr z,$f
		 call LookupEntry
		 ex de,hl
		 ld e,(hl)
		 inc hl
		 ld d,(hl)
		 dec de ;decrease size
		 ld (hl),d
		 dec hl
		 ld (hl),e
		 inc hl
		 inc hl
		 add hl,de
		 ld de,1
		 B_CALL DelMem
$$:
		 call ContinueMathInput
getinput_finish:
		 set textWrite, (IY + sGrFlags)
		 call	RestoreHooks
		 call LookupEntry
		 ex de,hl
		 ld e,(hl)
		 inc hl
		 ld d,(hl)
		 inc de
		 ld (hl),d
		 dec hl
		 ld (hl),e
		 inc hl
		 ex de,hl
		 add hl,de
		 ex de,hl
		 ld hl,1
		 B_CALL InsertMem
		 xor a
		 ld (de),a
		 ret

tokenhook:
	add a,e
	bit moleculeinput,(IY+asm_Flag1)
	ret z
	ld a,d
	or a
	jr nz,tokenhook_checklowercase
	ld a,e
	cp 60h ; nr 0
	ret c
	cp 72h+1 ;nr 9
	jr c,tokenhook_numbers
	ret nc
tokenhook_numbers:
	sra a
	add Lsub0-L0
replacetoken:
	ld b,a
	ld hl,localtokstr
	push hl
	xor a
	ld (hl),a
	inc hl
	inc a
	ld (hl),a
	inc hl
	ld (hl),b
	inc hl
	xor a
	ld (hl),a
	pop hl
	ret

tokenhook_checklowercase:
	dec a
	ret nz
	ld a,e
	cp 08h ;replace by small a
	ret c
	cp 3Ah+1
	ret nc
tokenhook_lowercase:
	sra a
	add "a"-04h
	jr replacetoken

getkeyhook:
	add a,e ;83h
	bit moleculeinput,(IY+asm_Flag1)
	jr z,getkeyhook_numberinput
	ld hl,getkeyhook_enablekeys
	ld bc,getkeyhook_enablekeys_end-getkeyhook_enablekeys
	cpir ;check if it's one of them
	jr z,getkeyhook_enable
	cp kEnter+1
	jr c,getkeyhook_enable
	cp kCapA
	jr c,$f
	cp kCapZ+1
	jr c,getkeyhook_enable
$$:
	cp kExtendEcho2					;for lowercase letters
	jr z,getkeyhook_lowercase
	cp k0
	jr c,getkeyhook_disable
	cp k9+1
	jr nc,getkeyhook_disable
getkeyhook_enable:
	or a
	ret

getkeyhook_lowercase:
	ld a,(keyExtend)
	sub kLa
	jr c,getkeyhook_disable
	cp 26
	jr nc,getkeyhook_disable
	ld e,a
	ld d,0
	ld hl,getkeyhook_lowercase_replacelist
	add hl,de
	cp 16
	jr c,getkeyhook_lowercase_keyreplace
	cp 24
	jr nc,getkeyhook_lowercase_keyreplace
getkeyhook_lowercase_keyextendreplace
	ld a,(hl)
	ld (keyExtend),a
	ld a,kExtendEcho
	or a
	ret
getkeyhook_lowercase_quit:
	ld a,kExtendEcho2
	or a
	ret

getkeyhook_lowercase_keyreplace:
	ld a,(hl)
	or a
	ret

getkeyhook_lowercase_replacelist:
	db   kTrace  ,  kClDrw  ,  kStd  ,  kTrig  ,  kBox  ,  kZIn  ,  kZOut  ,  kSquar  ,  kZInt  ,  kZPrev
	db   kDecml  ,  kZStat  ,  kUsrZm  ,  kPrtScr  ,  kZSto  ,  kText  ,kNPR,kNCR,kfnon,kfnoff
	db kSTPic,kRCPic,kSTGDB,kRCGDB,  kLine  ,  kVert  

;	db kRound,kPxlTest,kAug,kRowSwap,kRowPlus,kTimRow,kTRowP,kMax,kMin,kRToPr
;	db kRToPo,kPToRx,kPToRy,kMedian,kRandm,kMean,  kRoot  ,kSeq,  kFnInt  ,  kNDeriv
;	db   kEval  ,  kFMin  ,  kFMax  ,  kSpace  ,  kQuote  ,  kprtscr;kComma

getkeyhook_enablekeys:
	db kYequ,kWindow,kGraph,kQuit,kIns,kDel,kClear,kBOL,kEOL
getkeyhook_enablekeys_end:


getkeyhook_numberinput:
	ld hl,getkeyhook_disablekeys
	ld bc,getkeyhook_disablekeys_end-getkeyhook_disablekeys
	cpir ;check if it's one of them
	jr z,getkeyhook_disable

	cp kCONSTeA
	jr z,getkey_changekey_euler
	sub   0F3h 
	cp    6
   jp    c,getkey_changekey_lists ;if 2nd+7..9
   cp    9 
   jp    c,getkey_changekey_uvw ;if 2nd+7..9
	add	0F3
	ret

getkey_changekey_lists:
	add    kE2BT+14 ;lists
	jr getkey_changekey
getkey_changekey_uvw: ;uvw
	add    kE2BT+124-6
	jr getkey_changekey

getkey_changekey_euler:
	ld     a,kConstE ;euler
getkey_changekey:
   ld     (keyextend),a
   ld     a,kExtendEcho
	or a
	ret

getkeyhook_disable:
	xor a
	ret

getkeyhook_disablekeys:
	db kprgm,kmem,kZoom,kCalc
	db kWindow,kTblSet,kFormat,kCalc,kTrace,kTable,kMode,kLinkIO
;	db kList,kStat,kDraw,kMatrix ;{},l1 .. l6,distr also disabled ?
;	db kYequ,kGraph used
getkeyhook_disablekeys_end:

CreateEntry:                              ;Create the temp prog used for input
       call   LookupEntry
       ret    nc
       ld     hl,14h ;make sure there's enough place to contain any float
       B_CALL CreateProg
       ret
DeleteEntry:                              ;Delete the temp prog
       call   LookupEntry
       ret    c
       B_CALL DelVar
		 ret
LookupEntry:                              ;Lookup temp prog in symbol table
       ld     hl,EntryName
       rst    20h
       B_CALL ChkFindSym
       ret

RestoreHooks:
		ld hl,pointersaveplace	;from
		ld de,rawKeyHookPtr		;to
		ld bc,03						;size
		ldir							;copy rawkeyhookptr back
		ld de,tokenHookPtr	;to
		ld bc,03						;size
		ldir							;copy tokenHookPtr back
		ld a,(tokenhookbitsave) ; holds 0 if bit was z else FF
		or a
		jr nz,cleanupnow_sethome
		res tokenHookActive,(IY+tokenHookFlag)
		jr cleanupnow_skiphome
cleanupnow_sethome:
		set tokenHookActive,(IY+tokenHookFlag)
cleanupnow_skiphome:
		ld (getkeyhooksave),a ; holds 0 if bit was z else FF
		or a
		jr nz,cleanupnow_setrawkey
		res rawKeyHookActive,(IY+rawKeyHookFlag)
		jr cleanupnow_skiprawkey
cleanupnow_setrawkey:
		set rawKeyHookActive,(IY+rawKeyHookFlag)
cleanupnow_skiprawkey:
		 B_CALL ForceFullScreen ;added
       ret


Quit:
       call   DeleteEntry
		 call	RestoreHooks
       B_JUMP JForceCmdNoChar


SetupInputStuff:
                                          ;General input set-up stuff that needs
                                          ; to be run whether we're continuing
                                          ; the input or not.
       set    appAllowContext,(iy+APIFlg) ;To allow Yequ and Graph keys
       B_CALL GrBufClr
       B_CALL ClrScrnFull
;		 ld a,3
;		ld (8194h),a ;to make it return after the monreturn call

;		rst 28h ;maybe needed check later
;		dw 4D2Fh
;		B_CALL CloseEditBuf
SetupInputStuff_displaylooponly:
		ld hl,textShadow
		ld (hl)," "
		ld bc,15
		ld de,textShadow+1
		ldir
		ld hl,0
		ld (currow),hl
		ld hl,toplinestr
		bit moleculeinput,(IY+asm_Flag1)
		jr z,$f
		ld hl,moleculestr
$$:
		call PutSApp
		 ld hl,7*256+1
		 ld (winTop),hl
       B_CALL HomeUp ;doesn't work right when catalog has been called or split screen was on unless wintop has been set
		 bit moleculeinput,(IY+asm_Flag1)
		 ret nz
       ld b,6	;NEW
displayloop:
		 push bc
		 ld a,(Currentnr)
		 cp b
		 jr z,$f
		 ld a,b
		 call disponeline
$$:
		 pop bc
		 djnz displayloop
		 ret		 
SetupInputStuff_cursorvector:	;NEW
       B_CALL CursorOn
       ld     hl,gmMonVectors             ;Our custom vectors!
       B_CALL AppInit     
       ret
       B_CALL CursorOn
       ld     hl,gmMonVectors             ;Our custom vectors!
       B_CALL AppInit     
       ret

dispcurrentline:	;NEW
	ld a,(Currentnr)
disponeline:	;NEW
	push af
	ld hl,currow
	ld (hl),a
	inc hl
	ld (hl),1
	add a ;*2
	ld d,0
	ld e,a
	ld hl,strtable-2
	add hl,de
	B_CALL ldhlind
	call PutSApp
	ld a,"="
	B_CALL PutC
	B_CALL SetNumWindow
	ld a,(Currentnr)
	pop bc
	cp b
	ret z
	ld a,b
	cp 3
	jr c,disponeline_contanyway
disponeline_number:
	bit emptyedits,(IY+asm_Flag1)
	ret nz
disponeline_contanyway:
	call GetOP
	rst 20h
	ld a,9 ;15h
;	ld hl,currow
;	ld a,14
;	sub (hl)
	B_CALL FormEReal
	ld hl,OP3
	B_CALL WPutSEOL
;	B_CALL PutS
	ret
	
GetOP:	;NEW
	ld b,a
	add a
	add a
	add a
	add b ;*9
	ld hl,OPline1-9
	ld d,0
	ld e,a
	add hl,de
	ret

moleculestr:
	db "Enter molecule:",0

strtable:	;NEW
	dw str1
	dw str2
	dw str3
	dw str4
	dw str5
	dw str6

str1:	;NEW
	db "MOLMAS",0
str2:
	db "AT/MC",0
str3:
	db "MOLES",0
str4:
	db "MASS",0
str5:
	db "MOLEC",0
str6:
	db "ATOMS",0

OPs:	;NEW
	db 0,82h,12h,30h,0,0,0,0,0
	db 0,90h,12h,34h,56h,78h,90h,12h,34h
	db 0,83h,12h,3h,0,0,0,0,0
	db 0,81h,12h,0h,0,0,0,0,0
	db 0,84h,12h,3h,0,0,0,0,0
	db 0,81h,12h,0h,0,0,0,0,0

GetMathInput:
       call   SetupInputStuff
		 call   gmcxRedisp                  ;To get the softkey menu
GetMathInput_switchline:	;NEW
       call   CreateEntry
       set    cmdVirgin,(iy+cmdFlags)     ;Edit buffer is empty
       call   LookupEntry
       B_CALL SetEmptyEditPtr             ;Setup edit buffer
		 bit moleculeinput,(IY+asm_Flag1)
		 jr nz,GetMathInput_skipmultiline
       call dispcurrentline	;NEW
		 bit emptyedits,(IY+asm_Flag1)
		 jr nz,GetMathInput_skipmultiline
		 ld a,(Currentnr)
		 call GetOP
		 rst 20h
		 B_CALL OP1ToEdit
		 B_CALL BufToTop
		 B_CALL FDispEOL
GetMathInput_skipmultiline:
       ld     (TempSP),sp                 ;Save for later
		 call SetupInputStuff_cursorvector
		 res fracDrawLFont, (IY + fontFlags)
		 res 5,(iy+5);don't delete everything
		 set 6,(iy+5);firstchar
       B_CALL Mon

ContinueMathInput:
       call   SetupInputStuff_displaylooponly
		 bit moleculeinput,(IY+asm_Flag1)
		 call z,dispcurrentline	;NEW
		 call SetupInputStuff_cursorvector	;NEW
       call   SetupEditProg               ;Not empty...needs to be done differently
       ld     (TempSP),sp
ContinueMathInput_2:
		 bit moleculeinput,(IY+asm_Flag1)
		 jr nz,ContinueMathInput_EOW
		 B_CALL FDispEOL
		 jr ContinueMathInput_noEOW
ContinueMathInput_EOW:
       B_CALL DispEOW                     ;Restore old stuff to screen
ContinueMathInput_noEOW:
		 bit continue,(IY+asm_flag1)
		 jr z,$f
		 B_CALL GoToErrOffset 
$$:
       B_CALL IsEditEmpty                 ;Don't want to display a faulty char
       jr     z,SkipInitCurUnder
		 ld 	de,(editBtm)
       ld     hl,(editTail)
		 push hl
		 or a
		 sbc hl,de
		 pop hl
		 ld a," "
		 ld (OP3),a
		 jr z,$f
; ld a,(hl)
		 B_CALL Get_Tok_Strng
$$:
		 ld de,(currow)	;NEW
		 sla e
		 sla e
		 sla e
		 sla e ;*16
		 ld a,d
		 add e
		 ld d,0
		 ld e,a
		 ld hl,textShadow
		 add hl,de
       ld     a,(OP3)
       ld     (curUnder),a                ;Initialize under the cursor
       ld     (hl),a
SkipInitCurUnder:
       call   gmcxRedisp                  ;Display softkey menu stuff
       B_CALL Mon 
       
SetupEditProg:
       call   LookupEntry
       B_CALL EditProg                    ;Insert RAM, setup iMathPtrs
       set    editOpen,(iy+editFlags)     ;Editor is running
       ld     hl,(iMathPtr1)
       inc    hl
       inc    hl
       ld     (editTop),hl                ;Top of edit session
       push   hl
       ld     hl,(iMathPtr2)
       ld     (editCursor),hl
       push   hl
       ex     de,hl
       ld     hl,(iMathPtr3)
       B_CALL CpHLDE
       jr     nc,SetupEditProgSwapSkip
       ex     de,hl
SetupEditProgSwapSkip:
       ld     (editBtm),hl
       ld     (editTail),hl
       pop    hl
       pop    de
       or     a
       sbc    hl,de
       ret    z
       ld     c,l
       ld     b,h
       ld     hl,(editCursor)
       dec    hl
       ld     de,(editTail)
       dec    de
       lddr
       inc    hl
       ld     (editCursor),hl
       inc    de
       ld     (editTail),de
       ret




gmMonVectors:
       dw     gmcxMain
       dw     gmcxPPutAway
       dw     gmcxPutAway
       dw     gmcxRedisp
       dw     gmcxErrorEP
       dw     gmcxSizeWind
       db     0Eh                         ;Process menus + auto scroll + textsave

gmcxSizeWind: ;changed to allow recalling
       jr nc,gmcxSizeWind_savelastline
		 ld de,textShadow+60h ;start of seventh line
		 ld hl,lastlinesaveplace
		 ld bc,10h ;length of one line
		 ldir
		 call gmcxRedisp ;could also just place last line back
		 ret

gmcxSizeWind_savelastline:
		 ld hl,textShadow+60h ;start of seventh line
		 ld de,lastlinesaveplace
		 ld bc,10h ;length of one line
		 ldir
		 ret
		 

gmcxErrorEP:
                                          ;Not dealing with error goto either.
       ret


gmcxRedisp:
       ld     hl,(curRow)
       push   hl
		 ld hl,8*256+0
		 ld     (winTop),hl ;otherwise calling it from cxmain doesn't work (winbtm)
       B_CALL HomeUp ;doesn't work right when catalog has been called unless wintop has been set to 0
       ld     b,127-15
       ld     hl,textShadow
gmcxRedispLoop:                           ;Restore the screen from textShadow
       ld     a,(hl)
       B_CALL PutC
       inc    hl
       djnz   gmcxRedispLoop
;       ld     a,(hl)
 ;      B_CALL PutMap
       pop    hl
       ld     (curRow),hl
       ld     hl,SoftKeyText
		 bit moleculeinput,(IY+asm_Flag1)
		jr z,$f
		ld hl,SoftKeyMoleculeText
$$:
       call   SoftKey                     ;Display softkey menu0
       ret


gmcxPutAway:
       B_CALL CloseEditEqu                ;Close the equation
       B_CALL ReloadAppEntryVecs
       xor    a
       ld     (iy+textFlags),a
       call   DeleteEntry
		 call		RestoreHooks
       bit    monAbandon,(iy+monFlags)    ;Is calc turning off?
       jr     nz,gmcxPutAwayOff
       B_JUMP JForceCmdNoChar
gmcxPutAwayOff:
       B_JUMP PutAway



gmcxPPutAway:
       ret

gmcxMain:
		 ld hl,7*256+1
		 ld     (winTop),hl                      ;So the menu can't be overwritten
       call   gmcxDoMain
       ld hl,8*256+0
		 ld     (winTop),hl
       ret       
             
gmcxDoMain:
       cp     kGraph
       jp     z,gmcxMQuit
       cp     kYequ
       jp     z,gmcxMEnter
		 bit moleculeinput,(IY+asm_Flag1)
		 jr z,$f
		 cp kWindow
		 jp	z,gmcxMEnter
$$:
       cp     kQuit
       jp     z,gmcxMQuit
       cp     kEnter
       jp     z,gmcxMEnter
		 cp kPen ;wil display ? token
		 ret z
		 sub 	  40h
		 cp	  26 ;5A-40   ;range of possible apps
		 jp c,gmcxRedisp ;redisplay because user tried to start another app
		 add	  40h
		 bit moleculeinput,(IY+asm_Flag1)
		 jr z,gmcxDoMain_multiline
;		 cp kRecall
;		 jr nz,gmcxMNotrcl
;		 B_JUMP cxmainjump
;gmcxMNotrcl:
       cp     kLeft
       jr     nz,gmcxMNotLeft
       B_CALL CursorLeft
       ret
gmcxMNotLeft:
       cp     kRight
       jp     z,gmcxMRight
       cp     kUp
       jp     z,gmcxMUp
       cp     kDown
       jr     nz,gmcxMNotDown
       B_CALL CursorDown
       ret
gmcxMNotDown:
       cp     kBOL                               ;Beginning of Line
       jp     z,gmcxMBOL
       cp     kEOL                               ;End of Line
       jp     z,gmcxMEOL
       cp     kIns                               ;Insert
       jp     z,gmcxMIns
       cp     kDel
       jp     z,gmcxMDel
       cp     kClear
       jp     z,gmcxMClear
		 cp     echoStart1
       ret    c
       B_CALL InsDisp                            ;Display and update buffer
       ret

gmcxDoMain_multiline:
		 cp     kUp
       jp     z,gmcxMUp_multiline
       cp     kDown
       jr     z,gmcxMDown_multiline
       B_CALL InsDisp_oneline                          ;Display and update buffer
       ret

gmcxMRight:
		B_CALL cursorright
		ret


gmcxMClear:;Clear screen
;       bit    cmdVirgin,(iy+cmdFlags)
;       ret    nz doesn't work right with this enabled
       B_CALL IsEditEmpty
       jr     nz,gmcxMClear2
       B_CALL ClrWindow
       call   gmcxMBOL
       set    cmdVirgin,(iy+cmdFlags)
       B_CALL CanAlphIns
gmcxMClear2:
       B_CALL DispHead
       B_CALL EraseEOW
       B_CALL BufClear
       set    cmdVirgin,(iy+cmdFlags)
       B_CALL CanAlphIns
       ret

gmcxMDel:
       res    textInsMode,(iy+textFlags)
       B_CALL BufDelete                   ;Delete token from buffer
       B_CALL IsEditEmpty
       jr     nz,gmcxMDelNotEmpty
       set    cmdVirgin,(iy+cmdFlags)
gmcxMDelNotEmpty:
       B_CALL DispEOW                     ;Redisplay the rest of the toks
       ret

gmcxMIns:
       ld     a,(flags+textFlags)
       xor    10h                         ;Toggle Insert flag
       ld     (flags+textFlags),a
       ret
       
gmcxMBOL:                                 ;Beginning of line
       res    textScrolled,(iy+textFlags)
gmcxMBOLLoop:
       B_CALL IsAtTop                     ;Have we reached the beginning?
       ret    z                           ;If so, we're done
       B_CALL CursorLeft
       jr     gmcxMBOLLoop


gmcxMEOL:                                 ;End of line
       res    textScrolled,(iy+textFlags)
gmcxMEOLLoop:
       B_CALL IsAtBtm
       ret    z
       call   gmcxMRight
       jr     gmcxMEOLLoop

gmcxMUp:  
		B_CALL cursorup  
		ret

    
gmcxMQuit:
       call   gmcxQuitStuff
       jp     Quit

gmcxMEnter:
	set calconly,(IY+asm_Flag1)
	jr gmcxMEval_noreset

gmcxMUp_multiline:
	res updown,(IY+asm_Flag1)
	jr gmcxMEval
gmcxMDown_multiline:
	set  updown,(IY+asm_Flag1)
gmcxMEval:                              ;Parse edit buffer, and restore it
		 res calconly,(IY+asm_Flag1)
gmcxMEval_noreset:
       call   gmcxQuitStuff
       ld     sp,(TempSP)
       ld     hl,EntryName
       rst    20h
		 bit moleculeinput,(IY+asm_Flag1)
		 ret nz
		 bit 5,(iy+5);edited
		 jr z,gmcxMEval_switchline
		 call LookupEntry
		 ex de,hl
		 ld a,(hl)
		 inc hl
		 or (hl)
		 jr nz,gmcxMEval_notempty
		 bit emptyedits,(IY+asm_Flag1)
		 jr nz,gmcxMEval_switchline
		 jr ContinueMathInput
gmcxMEval_notempty:
       AppOnErr ParseError
       B_CALL ParseInp                    ;Parse it!
       ld     a,(OP1)
       and    1Fh                         ;Check if answer is a real
       jr     z,$f
		 B_JUMP ErrDataType
$$:
		 AppOffErr
		 B_CALL CleanAll							;delete all temp variables generated by parseinp
		 bit reqposint,(IY+asm_Flag1)
		 jr z,$f
		 B_CALL CkPosInt
		 jr nz,PosIntError
$$:
		 B_CALL PushOP1
       call DeleteEntry
		 B_CALL PopOP1
		 ;ret		 
		 ld a,(Currentnr)	;NEW
		 push af
		 call GetOP
		 ex de,hl
		 ld hl,OP1
		 ld bc,9
		 ldir
	;
	pop af
	cp 3 ;moles
	jr z,Moles
	cp 4;mass
	jr z,Mass
	cp 5;molecules
	jr z,Molecules
	cp 6
	jr nz,gmcxMEval_notempty2 ;temporary?
Atoms:
	call calcMolecules_fromAtoms
	;fallthrough
Molecules:
	call calcmoles_fromMolecules
	jr calccont
Mass:
	call calcmoles_fromMass
	;fallthrough
Moles:
	call calcmolecules_fromMoles
calccont:
	call calcmass
	call calcatoms
	;
		 bit emptyedits,(IY+asm_Flag1)
		 jr z,gmcxMEval_notempty2
		 res emptyedits,(IY+asm_Flag1)
gmcxMEval_notempty2:
		 call SetupInputStuff_displaylooponly
gmcxMEval_switchline:
		 bit calconly,(IY+asm_Flag1)
		 jp nz,GetMathInput_switchline
		 call dispcurrentline
		 call disponeline_number
		 ld hl,Currentnr
		 ld a,(hl)
		 bit updown,(IY+asm_Flag1)
		 jr z,$f
		 cp 6
		 jp z,GetMathInput_switchline
		 inc (hl)
		 jp GetMathInput_switchline
$$:
		 cp 3
		 jp z,GetMathInput_switchline
		 dec (hl)
		 jp GetMathInput_switchline

calcMolecules_fromAtoms
	ld hl,atomsfloat
	rst 20h
	ld hl,totatomsfloat
	call MovToOP2
	B_CALL FPDiv
	ld de,moleculesfloat
	call MovFrOP1
	ret

calcmoles_fromMass:
	ld hl,massfloat
	rst 20h
	ld hl,totaalfloat
	call MovToOP2
	B_CALL FPDiv
	ld de,molesfloat
	call MovFrOP1
	ret

calcmoles_fromMolecules:
	ld hl,moleculesfloat
	rst 20h
	ld hl,avogradoconst
	call MovToOP2
	B_CALL FPDiv
	ld de,molesfloat
	call MovFrOP1
	ret

calcmolecules_fromMoles:
	ld hl,molesfloat
	rst 20h
	ld hl,avogradoconst
	call MovToOP2
	B_CALL FPMult
	ld de,moleculesfloat
	call MovFrOP1
	ret

calcmass:
	ld a,(Currentnr)
	cp 4
	ret z
	ld hl,molesfloat
	rst 20h
	ld hl,totaalfloat
	call MovToOP2
	B_CALL FPMult
	ld de,massfloat
	call MovFrOP1
	ret

calcatoms:
	ld a,(Currentnr)
	cp 6
	ret z
	ld hl,moleculesfloat
	rst 20h
	ld hl,totatomsfloat
	call MovToOP2
	B_CALL FPMult
	ld de,atomsfloat
	call MovFrOP1
	ret

PosIntError:
       ld     hl,PosIntErrorTXT
       jr     ErrorCont
ParseError:
		 B_CALL dispErrorScreeN
		 res curLock,(IY+curFlags)
		 set continue, (IY+ asm_Flag1)
 		 ld hl,(965Dh) 
		 ld de,(965Bh) ;found in tios, calculates erroffset using these addresses as well
		 or a 
		 sbc hl,de
		 ld (errOffset),hl
       ld     hl,ParseErrorTXT
       jr     ErrorCont
TypeError:
       ld     hl,TypeErrorTXT
ErrorCont:
       push   hl
;       B_CALL ClrLCDFull
       B_CALL HomeUp
       pop    hl
       call   PutSApp
       B_CALL GetKey
       jp     ContinueMathInput
PosIntErrorTXT:
		 db	"ERR:ReqPosInt",0
       db     "You should enter"
       db     "a whole positive"
		 db     "number!",0
ParseErrorTXT:
       db     0,"An error occured"
       db     "while parsing.",0
TypeErrorTXT:
       db     "You didn't enter"
       db     "a number!",0
ResTXT:
       db     "Result:",0
gmcxQuitStuff:
       B_CALL CanAlphIns                  ;Turn off Alpha and Ins indicators
;       B_CALL DispTail                    ;Display rest of the stuff after cursor ;don't see the need and looks ugly
       B_CALL CloseEditEqu                ;Close the edit buffer
       B_CALL ReloadAppEntryVecs          ;Reload default system vectors
       ld     a,8                         ;Reset window to proper size
       ld     (winBtm),a
		 xor a
		 ld (wintop),a
       ret



EntryName:
       db     ProgObj,026h,"tmp",0
SoftKeyText2:
       db     "Edit",0
       db     0,0,0
       db     "QUIT",0
SoftKeyText:
       db     "Calc",0
       db     0,0,0
       db     "QUIT",0             

SoftKeyMoleculeText:
	db "Calc Moles",0
	db 0,0,0
	db "QUIT",0

SoftKey:
				;Input
				; hl -> key text
				;Ouput
				; soft keys are displayed to screen
	push	hl
	ld	bc,0007h
	ld	de,95*256+7
	ld	h,1
	B_CALL	ILine
	ld	b,19
	ld	d,b
	ld	e,0
	bit moleculeinput,(IY+asm_Flag1)
	jr nz,$f
	B_CALL	ILine
$$:
	ld	b,38
	ld	d,b
	B_CALL	ILine
	ld	b,57
	ld	d,b
	B_CALL	ILine
	ld	b,76
	ld	d,b
	B_CALL	ILine
       ld     b,0
       ld     d,b
       B_CALL ILine
       ld     b,95
       ld     d,b
       B_CALL ILine
	pop	hl
	ld	a,57
	ld	(penRow),a
	ld	a,3
SoftKeyLoop:					;loop to display text inside boxes
	ld	(penCol),a
	push	af
	call	VPutSApp
	pop	af
	add	a,19
	cp	98
	jr	nz,SoftKeyLoop
	ret

VPutSApp:                   ;Same as VPutS, but can be used with pointer in app
       ld     a,(hl)
       inc    hl
       or     a
       ret    z
       push   hl
       B_CALL VPutMap
       pop    hl
       jr     VPutSApp

PutSApp:                    ;Same as PutS, but can be used with pointer in app
       ld     a,(hl)
       inc    hl
       or     a
       ret    z
       B_CALL PutC
       jr     PutSApp

